#include <stdio.h>
#include <string.h>
#include <malloc.h>
#include "tscreen.h"
#include "mouse.h"
#include "key.h"

extern void WaitWindow( unsigned char* mess,
                 unsigned char* delm,
                 unsigned int bcolor,
                 unsigned int tcolor,
                 unsigned int dcolor,
                 unsigned int top = 0u,
                 unsigned int left = 0u,
                 unsigned int* topx = 0,
                 unsigned int* topy = 0,
                 unsigned int shadow = 1,
                 unsigned int frame = 1,
                 int maxlen = 0
           );



void WaitWindow( unsigned char* mess,
                 unsigned char* delm,
                 unsigned int bcolor,
                 unsigned int tcolor,
                 unsigned int dcolor,
                 unsigned int top,
                 unsigned int left,
                 unsigned int* topx,
                 unsigned int* topy,
                 unsigned int shadow,
                 unsigned int frame,
                 int maxlen
           )
{
    int i;
    int depth=0;
    int old=-1;
    int j,p,x,y;
    static unsigned char ddel[]="\xDA\xC4\xBF\xB3\xD9\xC4\xC0\xB3";
    unsigned char* delim;
    int oldforeground = Screen.foreground;
    int oldbackground = Screen.background;


    mouseLongUpdate();

    x=Screen.x;
    y=Screen.y;
    for( i=0; mess[i]; i++ ){
        if( mess[i]=='\r' ){
            depth++;
            if(i-old>maxlen)maxlen=i-old-1;
            old=i;
        }
    }
    if( !depth )maxlen=i;
    if(i-old>maxlen){
        maxlen=i-old-1;
    }
    left=left?left:(int)((Screen.maxCol-2-maxlen)>>1);
    top=top?top:(int)((Screen.maxRow-depth)>>1);

    if(top+depth>Screen.maxRow-4+(frame?0:3))
        top=Screen.maxRow-4-depth+(frame?0:3);
    if(left+maxlen>Screen.maxCol-3+(frame?0:3))
        left=Screen.maxCol-3-maxlen+(frame?0:3);

//    if(top<0)top=1;
//    if(left<0)left=1;

    if( topy )*topy=left;
    if( topx )*topx=top;

    Screen.foreground = dcolor;
    Screen.background = bcolor;

    delim=delm?delm:ddel;

    if( frame ){
        Screen.setxy( left, top );
        Screen.outc( delim[0] );
        for( i=0; i<maxlen; i++ )Screen.outc( delim[1] );
        Screen.outc( delim[2] );
    }
    for( i=0; i<=depth; i++ ){
        Screen.setxy( left+(frame?0:2), top+i+1+(frame?0:1) );
        if( frame )Screen.outc( delim[3] );
        for( old=0; old<maxlen; old++ )Screen.outc( ' ' );
        if( frame )Screen.outc( delim[7] );
    }
    if( frame ){
        Screen.setxy( left, top+depth+2 );
        Screen.outc( delim[6] );
        for( i=0; i<maxlen; i++ )Screen.outc( delim[5] );
        Screen.outc( delim[4] );
    }

    if( frame ){
        Screen.setxy( left-2, top-1 );
        for( i=0; i<maxlen+6; i++ )Screen.outc( ' ' );
    }
    for( i=0; i<depth+3; i++){
      if( frame ){
          Screen.setxy( left-2, top+i );
          Screen.outc( ' ' );
          Screen.outc( ' ' );
          Screen.setxy( left+maxlen+2, top+i );
          Screen.outc( ' ' );
          Screen.outc( ' ' );
        }
      if( shadow )Screen.screenAddr[ (top+i-1)*(Screen.maxCol<<1)+(left+maxlen+3)*2+1 ]&=~0x70;
    }
    if( shadow )Screen.screenAddr[ (top+i-1)*(Screen.maxCol<<1)+(left+maxlen+3)*2+1 ]&=~0x70;
    if( frame ){
        Screen.setxy( left-2, top+depth+3 );
        for( i=0; i<maxlen+6; i++ )Screen.outc( ' ' );
    }

    Screen.foreground = tcolor;
    Screen.background = bcolor;
    old=-1;

    for( i=0; i<=depth; i++ ){
        p=old+1;
        for( j=0,old=p+1 ; mess[old]!='\r'&& mess[old]; old++ )j++;
        Screen.setxy( left+1+(maxlen-j)/2+(frame?0:1) , top+1+i+(frame?0:1) );
        for( j=p; j<old; j++ )Screen.outc( mess[j] );
    }
    for( i=0; i<=maxlen+5; i++ )
        if( shadow )Screen.screenAddr[ (top+depth+2+1)*(Screen.maxCol<<1)+(left+i-2)*2+1 ]&=~0x70;
    Screen.foreground = oldforeground;
    Screen.background = oldbackground;
    Screen.setxy( x, y );

    mouseEndUpdate();
}

/*
int  confirmDlg( unsigned char* mess,
                 unsigned char* delm,
                 unsigned int bcolor,
                 unsigned int tcolor,
                 unsigned int dcolor,
                 unsigned int scolor,
                 unsigned int sback
	       )
{
  char *buff;
  unsigned int topx, topy;
  int i, rcnt=0;
  int oldc, oldb;
  char *Yes = "[Yes]";
  char *No  = "[No]";

  oldc = Screen.foreground;
  oldb = Screen.background;

//  buff = new char[ strlen( (char*)mess )+30 ];
  buff = (char*)alloca( strlen( (char*)mess )+30 );

  Screen.push();
  sprintf( buff, "%s\r   \r                 \r   ", mess );

  for( i = 0; buff[ i ]; i++ )if( buff[ i ] == '\r' )rcnt++;

  WaitWindow( (unsigned char*)buff, delm, bcolor, tcolor, dcolor, 0u, 0u, &topy, &topx );
//  delete buff;
  Screen.foreground = tcolor;
  Screen.background = bcolor;
  Screen.setxy( 40+2, topy+rcnt );
  Screen.outs( No );
  Screen.setxy( 40-5, topy+rcnt );
  Screen.foreground = scolor;
  Screen.background = sback;
  Screen.outs( Yes );
  i = 1;

  while( 1 ){
    switch( mgetch() ){
      case Tab:
	if( i ){
      Screen.setxy( 40-5, topy+rcnt );
	  Screen.foreground = tcolor;
	  Screen.background = bcolor;
      Screen.outs( Yes );
	  Screen.foreground = scolor;
	  Screen.background = sback;
      Screen.setxy( 40+2, topy+rcnt );
      Screen.outs( No );
	  i = 0;
	}else{
	  Screen.foreground = tcolor;
	  Screen.background = bcolor;
      Screen.setxy( 40+2, topy+rcnt );
      Screen.outs( No );
	  Screen.foreground = scolor;
	  Screen.background = sback;
      Screen.setxy( 40-5, topy+rcnt );
      Screen.outs( Yes );
	  i = 1;
	}
	break;
      case Enter:
	goto Quit;
      case 'Y':
      case 'y':
	i = 1;
	goto Quit;
      case Esc:
      case RMB:
      case 'N':
      case 'n':
	i = 0;
	mouseWaitRelease();
	goto Quit;
      case LMB:
	mouseWaitRelease();
    mouseY = (int)topy+rcnt;
    if( mouseY ){
	  if( mouseX >= 40-5 && mouseX < 40 ){
	    i = 1;
	    goto Quit;
	  }
	  if( mouseX >= 40+2 && mouseX < 40+2+4 ){
	    i = 0;
	    goto Quit;
	  }
	}
	break;
      case Left:
	if( !i )mungetch( Tab );
	break;
      case Right:
	if( i )mungetch( Tab );
	break;
    }
  }
Quit:
  Screen.pop();
  Screen.foreground = oldc;
  Screen.background = oldb;
  return i;
}
*/

void wait( char *mess, int bkg, int clr )
{
  Screen.push();
  WaitWindow( (unsigned char*)mess, NULL, bkg, clr, clr );
  mgetch();
  mouseWaitRelease();
  Screen.pop();
}
