INCLUDE         lexdef.inc

Routine         get_ndl
Routine         get_timeout
Routine         stype
Routine         getutc
Routine         getszone
Routine         getsnet
Routine         getsnode
Routine         getspoint
Routine         getsel
Routine         preand
Routine         prenot
Routine         getseg
Routine         getoffset
Routine         getstinfo
Routine         gettrname

                lexdef

Syntax          config
State           start
TranKeyword     'NODELIST'              ,nodelist
TranKeyword     'SCREENSAVERTIMEOUT'    ,timeout
TranKeyword     'SCREENSAVERTYPE'       ,savertype
TranKeyword     'UTC'                   ,utc
TranKeyword     'STARTADDRESS'          ,startlevel
TranKeyword     'SELECT'                ,select
TranKeyword     'STARTINFO'             ,stop           ,getstinfo
TranKeyword     'NOTRUENAME'            ,stop           ,gettrname
Tran            LEX_NULL                ,stop

State           nodelist
Tran            LEX_BLANKS              ,nodelist_
State           nodelist_
Tran            LEX_FNM                 ,stop           ,get_ndl

State           timeout
Tran            LEX_BLANKS              ,timeout_
State           timeout_
TranNumber                              ,stop           ,get_timeout

State           savertype
Tran            LEX_BLANKS              ,savertype_
State           savertype_
TranKeyword     'STARFIELD'             ,stop           ,stype
TranKeyword     'CLOCK'                 ,stop           ,stype
TranKeyword     'RANDOM'                ,stop           ,stype

State           utc
TranNumber                              ,stop           ,getutc

State           startlevel
TranSyntax      Address                 ,stop

State           select
TranKeyword     '.NOT.'                 ,select          ,prenot
Tran            LEX_STRING              ,SelComma        ,getsel

State           SelComma
TranKeyword     '.AND.'                 ,select          ,preand
Tran            LEX_NULL                ,stop

State           stop
TranKeyword     ';'                     ,LEX_SUCCESS
Tran            LEX_EOS                 ,LEX_SUCCESS

; ---------------------- ADDRESS ----------------------------

Syntax          Address

State           s_zone
TranNumber                              ,snet           ,getszone
Tran            LEX_NULL                ,snet

State           snet
TranKeyword     ':'                     ,s_net
Tran            LEX_NULL                ,snode

State           s_net
TranNumber                              ,snode          ,getsnet
Tran            LEX_NULL                ,LEX_SUCCESS

State           snode
TranKeyword     '/'                     ,s_node
Tran            LEX_NULL                ,spoint

State           s_node
TranNumber                              ,spoint        ,getsnode
Tran            LEX_NULL                ,LEX_SUCCESS

State           spoint
TranKeyword     '.'                     ,s_point
Tran            LEX_NULL                ,LEX_SUCCESS

State           s_point
TranNumber                              ,LEX_SUCCESS    ,getspoint
Tran            LEX_NULL                ,LEX_SUCCESS

; ----------------------- MEMORY ----------------------------------

Syntax          Memory
State           m_start
TranKeyword     '/A:'                   ,s_segment

State           s_segment
TranNumber      16                      ,s_coffset       ,getseg

State           s_coffset
TranKeyword     ':'                     ,s_offset

State           s_offset
TranNumber      16                      ,LEX_SUCCESS     ,getoffset

                lexend
                end
