#include <stdio.h>
#include <string.h>
#include "sf-node.h"
#include "mouse.h"

void about()
{
  int i;

  i=strchr(copyright,',')-copyright;
  mouseWaitRelease();
  sprintf( iobuff, "  \r\
  %s, %-35s\r\
  %-49.*s\r\
  %-49.49s\r\
  (2:5030/143.23@fidonet,135:7000/555.13@OopsNet)  \r\
  %-49s\r  ", product, prodwide,
              i, copyright,
              copyright+i+2,
              compiled );
  wait( iobuff, bkgInfo, clrInfo );
}

void help()
{
  int i;
  static char *key[] =   {
                          "Alt/H, F1",
                          "ALt/A, F9",
                          "Alt/F, F7",
                          "Alt/M, Ins",
                          "Alt/S",
                          "Alt/I, TAB",
                          "Alt/N",
                          "Any Letter",
                          "Ctrl/Enter",
                          "BackSpace",
                          "Home, End, Up, Dn",
                          "PgUp, PgDn",
                          "Left, RMB",
                          "Right, Double LMB",
                          "Esc",
                          "Enter"
                         };
  static char *descr[] = {
                          "This help",
                          "About",
                          "Global Find",
                          "Match AKA",
                          "Sort nodelist",
                          "Toggle node info",
                          "Select active",
                          "Quick search on",
                          "Quick search next",
                          "Force screensaver",
                          0,
                          "Navigate",
                          "Leave level",
                          "Enter level",
                          "Abort",
                          "Select'n'Exit"
                         };


  strcpy( iobuff, "  " );
  for( i = 0; i < 16; i++ ){
      sprintf( iobuff+strlen(iobuff), "\r  %-19s", key[i] );
      if( descr[i] ){
        strcat( iobuff, "- " );
        sprintf( iobuff+strlen(iobuff), "%-19s", descr[i] );
      }else sprintf( iobuff+strlen(iobuff), "%21s", "" );
  }
  strcat( iobuff, "\r  " );

  wait( iobuff, bkgInfo, clrInfo );
}
