#ifndef _NDL_H_
#define _NDL_H_

#include <string.h>

#define MAX_NODE_HDR    25

typedef struct{
    unsigned int Zone;
    unsigned int Net;
    unsigned int Node;
    unsigned int Point;
}tAddress;

typedef struct{
    tAddress        Address;    //.$00: 4D-p 㧫
    unsigned int    RouteNode;  //.$08: p Hub-Route
    unsigned char   NdlNo;      //.$0A: No    
    unsigned long   NdlOfs;     //.$0B: ᬥ饭  p樨  㧫  
}tNodeIdxRec;

typedef struct{
    unsigned char NameLen;      //-  
    char     Name[12];          //- a
    unsigned long Time;         //- 祭 
}tNodeHdrRec;

typedef struct{
    unsigned long Size;         //-pp 
    unsigned char TotalNdls;    //-饥 ᫮ 祭 ⮢
}tNodeIdxHdr;

inline int operator==( const tAddress a, const tAddress b )
    { return !memcmp(&a,&b,sizeof(tAddress)); };

inline int operator!=( const tAddress a, const tAddress b )
    { return memcmp(&a,&b,sizeof(tAddress)); };

int operator <( const tAddress a, const tAddress b );


#endif
