#include <string.h>
#include "sf-node.h"

char * gettoken( char *dest, const char *src )
{
    while( *src && *src != ',' )*dest++ = *src++;
    *dest = 0;
    if( *src )src++;
    return (char*)src;
}

int parseNdl( const char *str, NdlLine& ndl )
{
    char * last;
    char iobuff[64];

    if( str[0] == ';' )return 1;

    last = gettoken( ndl.Royal, str );
    last = gettoken( iobuff, last );
    last = gettoken( ndl.BBS_Name, last );
    last = gettoken( ndl.Place, last );
    gettoken( ndl.SysOp, last );
    while( last = strchr( ndl.BBS_Name, '_' ) )*last=' ';
    while( last = strchr( ndl.Place, '_' ) )*last=' ';
    while( last = strchr( ndl.SysOp, '_' ) )*last=' ';
    return 0;
}

char* expandStr( char* ptr, const char * c )
{
    int i,k=0;
    char * last;
    static char iobuff[128];

    last = gettoken( iobuff, c );
    for( i=strlen(iobuff); i<8; i++ )iobuff[i] = ' ';
    strcpy( iobuff+8, ptr );
    for( i=strlen(iobuff); i<26; i++ )iobuff[i] = ' ';
    for( ; last[k]!=','; i++ )iobuff[i] = last[k++];
    for( ; i<56 ; i++ )iobuff[i]=' ';
    for( k++; last[k]; i++, k++ )iobuff[i] = last[k];
    iobuff[i] = 0;
    return iobuff;

/*
    for( i=strlen(ptr); i<18; i++ )ptr[i] = ' ';
    for( ; c[k]!=','; i++ )ptr[i] = c[k++];
    for( ; i<54 ; i++ )ptr[i]=' ';
    for( k++; c[k]; i++, k++ )ptr[i] = c[k];
    ptr[i] = 0;
*/
}
