#include <stdlib.h>
#include <dos.h>
#include <time.h>
#include "tscreen.h"
#include "mouse.h"
#include "colors.h"
#include "slice.h"

#define Uhit (mkbhit() || mouseY!=my || mouseX!=mx || shiftState()&0x0F)

extern char saverType;

void sliceDelay( int n )
{
	long start = clock();

/*
    releaseSlice();
	start = n - (clock() - start)/CLK_TCK/1000l;
	if( start > 0 )delay( (int)start );
*/
    while(  ((clock() - start)*1000l/CLK_TCK) < n )releaseSlice();
}

void drawnum( int num, int x, int y )
{
    if( num==0 || num==2 || num==3 || num>4 ){
    Screen.setxy( x+1, y );
    Screen.outs( "");
    }
    if( num==0 || num==4 || num==5 || num==6 || num==8 || num==9 ){
    Screen.setxy( x, y+1 );
    Screen.outc( '' );
    Screen.setxy( x, y+2 );
    Screen.outc( '' );
    Screen.setxy( x, y+3 );
    Screen.outc( '' );
    }
    if( num==0 || num==1 || num==2 || num==3 || num==4 || num>6 ){
    Screen.setxy( x+7, y+1 );
    Screen.outc( '' );
    Screen.setxy( x+7, y+2 );
    Screen.outc( '' );
    Screen.setxy( x+7, y+3 );
    Screen.outc( '' );
    }
    if( num==2 || num==3 || num==4 || num==5 || num==6 || num==8 || num==9 ){
    Screen.setxy( x+1, y+4 );
    Screen.outs( "");
    }
    if( num==0 || num==2 || num==6 || num==8 ){
    Screen.setxy( x, y+5 );
    Screen.outc( '' );
    Screen.setxy( x, y+6 );
    Screen.outc( '' );
    Screen.setxy( x, y+7 );
    Screen.outc( '' );
    }
    if( num!=2 ){
    Screen.setxy( x+7, y+5 );
    Screen.outc( '' );
    Screen.setxy( x+7, y+6 );
        Screen.outc( '' );
        Screen.setxy( x+7, y+7 );
        Screen.outc( '' );
    }
    if( num==2 || num==3 || num==5 || num==6 || num==8 || num==9 || num==0 ){
        Screen.setxy( x+1, y+8 );
        Screen.outs( "");
    }
}

void clockSaver()
{
    int x, y;
    int mx, my;
    int min;
    int i;
    struct tm *timep;
    time_t ltime;

    Screen.push();
    Screen.background = BLACK;
    Screen.foreground = LIGHTGRAY;
    Screen.cursoroff();
    disableMouse();
    mouseStatus();
    mx = mouseX;
    my = mouseY;
    Screen.clrScreen();
//    randomize();
    srand( (int)clock() );
    while( !Uhit ){
        time( &ltime );
        timep = localtime( &ltime );
        min = timep->tm_min;
        x=(int)(rand()*((long)Screen.maxCol-42l)/32767+1);
        y=(int)(rand()*((long)Screen.maxRow-10l)/32767+1);
        drawnum( (int)(timep->tm_hour/10), x, y );
        drawnum( timep->tm_hour-((int)(timep->tm_hour/10))*10, x+9, y );
        drawnum( (int)(timep->tm_min/10), x+21, y );
        drawnum( timep->tm_min-((int)(timep->tm_min/10))*10, x+30, y );
        Screen.setxy( x+40, y+8 );
        Screen.outc( 4 );
        mouseStatus();
        while( min==timep->tm_min && !Uhit ){
            time( &ltime );
            timep = (tm*)localtime( &ltime );
            Screen.setxy( x+19, y+3 );
            Screen.outc( 4 );
            Screen.setxy( x+19, y+6 );
            Screen.outc( 4 );
            for( i=0; i<10; i++){
                mouseStatus();
                if( Uhit )goto STOP;
                sliceDelay( 100 );
            }
            Screen.setxy( x+19, y+3 );
            Screen.outc(' ');
            Screen.setxy( x+19, y+6 );
            Screen.outc(' ');
            for( i=0; i<10; i++){
                mouseStatus();
                if( Uhit )goto STOP;
                sliceDelay( 100 );
            }
        }
        Screen.clrScreen();
        mouseStatus();
    }
STOP:
    enableMouse();
    Screen.pop();
}

void starField()
{
    int x[40], y[40];
    int i;
    int mx, my;

    Screen.push();
    Screen.background = BLACK;
    Screen.foreground = WHITE;
    Screen.cursoroff();
    disableMouse();
    mouseStatus();
    mx = mouseX;
    my = mouseY;
    Screen.clrScreen();
//    randomize();
    srand( (int)clock() );
    for( i=0; i<40; i++){
        x[i]=(int)(rand()*((long)Screen.maxCol-1l)/32767+1);
        y[i]=(int)(rand()*((long)Screen.maxRow-1l)/32767+1);
        Screen.setxy( x[i], y[i] );
        Screen.outc( '' );
    }
    mouseStatus();
    while( !Uhit ){
        i = (int)(rand()*40l/32767);
        Screen.setxy( x[i], y[i] );
        Screen.outc( '' );
        mouseStatus();
        if( Uhit )goto STOP;
	sliceDelay( 120 );
        Screen.setxy( x[i], y[i] );
        Screen.outc( '' );
        mouseStatus();
        if( Uhit )goto STOP;
	sliceDelay( 120 );
        Screen.setxy( x[i], y[i] );
        Screen.outc( '' );
        mouseStatus();
        if( Uhit )goto STOP;
	sliceDelay( 120 );
        Screen.setxy( x[i], y[i] );
        Screen.outc( '*' );
        mouseStatus();
        if( Uhit )goto STOP;
	sliceDelay( 120 );
        Screen.setxy( x[i], y[i] );
        Screen.outc( '' );
        mouseStatus();
        if( Uhit )goto STOP;
	sliceDelay( 120 );
        Screen.setxy( x[i], y[i] );
        Screen.outc( ' ' );
        mouseStatus();
        if( Uhit )goto STOP;
    sliceDelay( (int)(rand()*120l/32767) );
        x[i]=(int)(rand()*((long)Screen.maxCol-1l)/32767+1);
        y[i]=(int)(rand()*((long)Screen.maxRow-1l)/32767+1);
        Screen.setxy( x[i], y[i] );
        Screen.outc( '' );
        mouseStatus();
    }
STOP:
    enableMouse();
    Screen.pop();
}

void screenSaver()
{
    switch( saverType ){
        case 'S': starField();
                  break;
        case 'C': clockSaver();
                  break;
        case 'R':
        default:
//                  randomize();
                  srand( (int)clock() );
                  switch( rand()*2l/32767 ){
                    case 0: starField();
                            break;
                    case 1: clockSaver();
                            break;
                  }
    }
}

