#include <io.h>
#include "ndl.h"
#include "sf-node.h"

int operator <( const tAddress a, const tAddress b )
{
    if( a.Zone  > b.Zone )return 0;
    if( a.Zone  < b.Zone )return 1;
    if( a.Net   > b.Net  )return 0;
    if( a.Net   < b.Net  )return 1;
    if( a.Node  > b.Node )return 0;
    if( a.Node  < b.Node )return 1;
    if( a.Point < b.Point)return 1;
    return 0;
}

long searchNode( tAddress* address, long offset )
{
    unsigned int i, len;
    long l=0;
    tNodeIdxRec *NodeIdxRec;

    lseek( handleIdx, offset, SEEK_SET );
    do{
        len = read( handleIdx, iobuff, sizeof(tNodeIdxRec)*100 )/sizeof(tNodeIdxRec);
        NodeIdxRec = (tNodeIdxRec*)iobuff;
        if( NodeIdxRec[len-1].Address < *address ){
            l += len;
            continue;
        }
        for( i=0; i<len; i++ ){
            if( *address == NodeIdxRec[i].Address )goto STOP;
            l++;
        }
    }while( len == 100 );
STOP:
    l = offset+l*sizeof(tNodeIdxRec);
    lseek( handleIdx, l, SEEK_SET );
    return l;
}
