#include <malloc.h>
#include <io.h>
#include <process.h>
#include "view.h"
#include "sf-node.h"
#include "key.h"
#include "mouse.h"
#include "slice.h"

static f = 0;

void TPointView::init()
{
    unsigned int len, i, k;
    tNodeIdxRec *NodeIdxRec;

    sliceCritical = 1;
    level = 4;

    StatusLine.say( readingIndex );
    if( !f ){
        lineCnt = 0;
        curPos = curScr = 0;
    }else f = 0;
    if( !lineCnt ){
        offset = searchNode( CurPtr, NodeView.offset );
        do{
            len = read( handleIdx, iobuff, sizeof(tNodeIdxRec)*100 )/sizeof(tNodeIdxRec);
            NodeIdxRec = (tNodeIdxRec*)iobuff;
            for( i=0; i<len; i++ ){
                if( CurPtr->Zone != NodeIdxRec[i].Address.Zone ||
                    CurPtr->Net != NodeIdxRec[i].Address.Net ||
                    CurPtr->Node != NodeIdxRec[i].Address.Node )goto STOP;
                lineCnt++;
            }
        }while( len == 100 );
    }
STOP:
    lseek( handleIdx, offset, SEEK_SET );
    allocList( lineCnt );
    for( k = 0; k < lineCnt;  ){
        len = read( handleIdx, iobuff, sizeof(tNodeIdxRec)*100 )/sizeof(tNodeIdxRec);
        NodeIdxRec = (tNodeIdxRec*)iobuff;
        for( i=0; i<len && k<lineCnt; i++ ){
            NodeList[ k++ ].NodeIdxRec = NodeIdxRec[i];
        }
    }
    head = NodeList;
    current = &NodeList[ curPos ];
    collectStr();
    if( insearch || StartupAddress.Point ){
        while( ((tAddress*)current)->Point < StartupAddress.Point && curPos+1 < lineCnt ){
               curPos++;
               next();
        }
        StartupAddress.Point = 0;
        if( lineCnt - curPos < wLines ){
            curScr = wLines - (lineCnt - curPos);
            if( wLines > lineCnt )curScr -= (wLines-lineCnt);
        }
        if( insearch )mungetch( CInvalidate );
        TView::NoDraw = insearch = 0;
    }
    if( order )sort( order );
    sliceCritical = 0;
}

void TPointView::handleEvent()
{
    switch( key ){
        case RMB:
        case Left:  mungetch( CQuit );
                    releaseStr();
                    clrWindow();
                    NodeView.init();
                    order = 0;
                    stableOn = 0;
                    mouseWaitRelease();
                    break;
        case 0xF01: CurPtr = (tAddress*)current;
                    CurAddr = *CurPtr;
                    if( SearchView.AKAmatching )SearchView.getSysop((char*)current);
                    f = 1;
                    releaseStr();
                    clrWindow();
                    SearchView.activate();
                    SearchView.clrWindow();
                    SearchView.lineCnt = 0;
                    if( !insearch ){
                        init();
                        show( curPos );
                    }
                    stableOn = 0;
                    break;
        case 0xF03:
                    order = 0;
                    if( StartupAddress.Node == CurAddr.Node && StartupAddress.Net == CurAddr.Net && StartupAddress.Zone == CurAddr.Zone ){
                        StartupAddress.Zone = StartupAddress.Net = StartupAddress.Node = 0;
                        CurAddr.Zone = CurAddr.Net = CurAddr.Node = 0;
                        curPos = curScr = 0;
                        init();
                    }else{
                        mungetch( CQuit );
                        mungetch( 0xF03 );
                        f = 0;
                    }
                    break;
        default:    TLevelView::handleEvent();
    }
}
