#include <malloc.h>
#include <io.h>
#include <process.h>
#include <stdio.h>
#include <string.h>
#include <fcntl.h>
#include <dos.h>
#include <share.h>
#include "view.h"
#include "sf-node.h"
#include "key.h"
#include "mouse.h"
#include "country.h"
#include "slice.h"

extern char ndlBuff[];

TSearchView::TSearchView()
{
    AKAmatching = 0;
}

void TSearchView::init()
{
    unsigned int len, i, n;
    tNodeIdxRec *NodeIdxRec = (tNodeIdxRec*)iobuff;
    char fnm[70];
    char *name;
    unsigned long ftime;
    extern void normalize( char *buff, int l );
    extern int checkSelection( char* buff );
    int last = -1;
    int handle = -1;
    char tmpBuff[151];
    char *fndStr = (char*)alloca( strlen(findStr)+1 );
    int oldIdle=idleMax;

    sliceCritical = 1;
    idleMax=0;
    level = 5;
    lineCnt = 0;
    curPos = curScr = 0;
    order = 0;
    lseek( handleIdx, IdxOffset, SEEK_SET );
    strcpy( fnm, nodepath );
    name = fnm+strlen( fnm );
    allocList( 128 );
    memset( NodeList, 0, sizeof(tListItem)<<7 );
    strcpy( fndStr, findStr );
    upper( fndStr );
    head = NodeList;
    current = NodeList;
    do{
        if( mkbhit() == Esc ){
            mgetch();
            ::wait( "  \r  Search aborted  \r  ", bkgError, clrError );
            break;
        }
        StatusLine.say( readingIndex );
        len = read( handleIdx, iobuff, sizeof(tNodeIdxRec)*100 )/sizeof(tNodeIdxRec);
//        NodeIdxRec = (tNodeIdxRec*)iobuff;
        StatusLine.say( readingNodelist );
        for( i=0; i<len; i++ ){
            n = ( NodeIdxRec[i].NdlNo & 0x3F ) - 1;
            if( last != n ){
                close( handle );
                strncpy( name, headRec[ n ].Name, (int)(headRec[ n ].NameLen) );
                name[ (int)(headRec[ n ].NameLen) ] = 0;
                handle = sopen( fnm, O_RDONLY|O_BINARY, SH_DENYWR );
                if( handle < 0 ){
                    sprintf( iobuff, "  \r  Cannot open nodelist  \r  %s  \r  ", fnm );
                    error( iobuff, 2 );
                }
                _dos_getftime( handle, ((unsigned short*)&ftime)+1, (unsigned short*)&ftime );
                if( ftime != headRec[n].Time ){
                    sprintf( iobuff, recompileMess, fnm );
                    error( iobuff, 4 );
                }
                last = n;
            }
            lseek( handle, NodeIdxRec[i].NdlOfs, SEEK_SET );
            read( handle, (void*)ndlBuff, 150 );
            normalize( ndlBuff, 149 );
            strcpy( tmpBuff, ndlBuff );
            upper( ndlBuff );
            if( strstr( ndlBuff, fndStr ) ){
                NodeList[ lineCnt ].NodeIdxRec = NodeIdxRec[i];
                parseNodeLine( tmpBuff, lineCnt );
                if( checkSelection( ndlBuff ) )NodeList[lineCnt].NodeIdxRec.NdlNo |= 0x40;
                if( ++lineCnt == 128 ){
                    close( handle );
                    goto STOP;
                }
                if( lineCnt <= wLines )draw(0);
            }
        }
    }while( len == 100 );
    close( handle );
    if( !lineCnt ){
        ::wait( "   \r   String was not found   \r   ", backgroundWindow, colorWindow );
        goto QUIT;
    }

STOP:
//    collectStr();
//    if( order )sort( order );
QUIT:
    AKAmatching = 0;
    sliceCritical = 0;
    idleMax=oldIdle;
}

void  TSearchView::handleEvent()
{
    switch( key ){
        case RMB:
        case Left:  mungetch( CQuit );
                    releaseStr();
                    clrWindow();
                    order = 0;
                    stableOn = 0;
                    break;
        case dblLMB:
        case Right:
                    StartupAddress = *(tAddress*)current;
                    TView::NoDraw = insearch = 1;
                    mungetch( CQuit );
                    mungetch( 0xF03 );
                    releaseStr();
                    clrWindow();
                    order = 0;
                    stableOn = 0;
                    break;
        default:    TLevelView::handleEvent();
    }
}

void TSearchView::getSysop( char* ptr )
{
    ::getSysop( findStr, ((tListItem*)ptr)->collection );
    ptr = findStr;
    while( ptr = strchr( ptr, ' ' ) )*ptr = '_';
}

