#ifndef _NDL_H_
#define _NDL_H_

#define MAX_NODE_HDR    25

#pragma ZTC align 1

typedef struct{
    short Zone;
    short Net;
    short Node;
    short Point;
}tAddress;

typedef struct{
    tAddress        Address;    //.$00: 4D-p 㧫
    short  RouteNode;           //.$08: p Hub-Route
    unsigned char   NdlNo;      //.$0A: No    
    unsigned long   NdlOfs;     //.$0B: ᬥ饭  p樨  㧫  
}tNodeIdxRec;

typedef struct{
    unsigned char NameLen;      //-  
    char     Name[12];          //- a
    unsigned long Time;         //- 祭 
}tNodeHdrRec;

typedef struct{
    unsigned long Size;         //-pp 
    unsigned char TotalNdls;    //-饥 ᫮ 祭 ⮢
}tNodeIdxHdr;

#pragma ZTC align


void setAddress( tAddress &add, short Zone=-1, short Net=-1, short Node=-1, short Point=-1 );
int operator==( tAddress a, tAddress b );
int operator <( tAddress a, tAddress b );
int operator >( tAddress a, tAddress b );

#endif
