#include "ndl.h"

void setAddress( tAddress &add, short Zone, short Net, short Node, short Point )
{
    add.Zone  = Zone;
    add.Net   = Net;
    add.Node  = Node;
    add.Point = Point;
}

int operator==( tAddress a, tAddress b )
{
    return a.Zone == b.Zone && a.Net == b.Net && a.Node == b.Node
	&& a.Point == b.Point;
}

int operator <( tAddress a, tAddress b )
{
    if( a.Zone  > b.Zone )return 0;
    if( a.Zone  < b.Zone )return 1;
    if( a.Net   > b.Net  )return 0;
    if( a.Net   < b.Net  )return 1;
    if( a.Node  > b.Node )return 0;
    if( a.Node  < b.Node )return 1;
    if( a.Point > b.Point)return 0;
    if( a.Point < b.Point)return 1;
    return 0;
}

int operator >( tAddress a, tAddress b )
{
    return !((a < b) || (a==b));
}
