#include <malloc.h>
#include <io.h>
#include <process.h>
#include <stdio.h>
#include "view.h"
#include "sf-node.h"
#include "key.h"
#include "mouse.h"
#include "slice.h"

static f = 0;

void TNodeView::init()
{
    unsigned int len, i, k, Node=0xFFFF;
    tNodeIdxRec *NodeIdxRec;

    sliceCritical = 1;
    level = 3;

    StatusLine.say( readingIndex );
    if( !f ){
        lineCnt = 0;
        curPos = curScr = 0;
    }else f = 0;
    if( !lineCnt ){
        offset = searchNode( CurPtr, NetView.offset );
        do{
            len = read( handleIdx, iobuff, sizeof(tNodeIdxRec)*100 )/sizeof(tNodeIdxRec);
            NodeIdxRec = (tNodeIdxRec*)iobuff;
            for( i=0; i<len; i++ ){
                if( CurPtr->Zone != NodeIdxRec[i].Address.Zone ||
                    CurPtr->Net != NodeIdxRec[i].Address.Net )goto STOP;
                if( Node != NodeIdxRec[i].Address.Node ){
                    lineCnt++;
                    Node = NodeIdxRec[i].Address.Node;
                }
            }
        }while( len == 100 );
    }
STOP:
    lseek( handleIdx, offset, SEEK_SET );
    allocList( lineCnt );
    Node = 0xFFFF;
    for( k = 0; ;  ){
        len = read( handleIdx, iobuff, sizeof(tNodeIdxRec)*100 )/sizeof(tNodeIdxRec);
        NodeIdxRec = (tNodeIdxRec*)iobuff;
        for( i=0; i<len; i++ ){
            if( k &&
                ( NodeIdxRec[i].Address.Net  != NodeList[0].NodeIdxRec.Address.Net ||
                  NodeIdxRec[i].Address.Zone != NodeList[0].NodeIdxRec.Address.Zone )
              )goto STP;
            if( Node != NodeIdxRec[i].Address.Node ){
                if( k < lineCnt ){
                    Node = NodeIdxRec[i].Address.Node;
                    NodeList[ k++ ].NodeIdxRec = NodeIdxRec[i];
                    continue;
                }
            }else NodeList[ k-1 ].NodeIdxRec.NdlNo |= 0x80;
            if( k == lineCnt )goto STP;
        }
        if( k == lineCnt )goto STP;
    }
STP:
    head = NodeList;
    current = &NodeList[ curPos ];
    if( insearch || StartupAddress.Node || StartupAddress.Point ){
        while( ((tAddress*)current)->Node < StartupAddress.Node && curPos+1 < lineCnt ){
               curPos++;
               next();
        }
        if( ((tAddress*)current)->Node == StartupAddress.Node ){
                CurAddr.Node = StartupAddress.Node = 0;
                if( lineCnt - curPos < wLines ){
                    curScr = wLines - (lineCnt - curPos);
                    if( wLines > lineCnt )curScr -= (wLines-lineCnt);
                }
                if( !insearch || StartupAddress.Point ){
                    key = 0xF02;
                    handleEvent();
                }else{
                    collectStr();
                    if( insearch )mungetch( CInvalidate );
                    TView::NoDraw = insearch = 0;
                }
        }else{
               curPos = curScr = 0;
               current = head;
               sprintf( iobuff, "  \r  Node %u:%u/%u%s", ((tAddress*)head)->Zone, ((tAddress*)head)->Net, StartupAddress.Node, doesntExist );
               WaitWindow( (unsigned char*)iobuff,
                     NULL, bkgError, clrError, clrError );
               StartupAddress.Node = StartupAddress.Point = 0;
               insearch = 0;
               collectStr();
               mgetch();
               mouseWaitRelease();
        }
    }else{
        collectStr();
    }
    if( order )sort( order );
    sliceCritical = 0;
}

void  TNodeView::handleEvent()
{
    switch( key ){
        case RMB:
        case Left:  mungetch( CQuit );
                    releaseStr();
                    clrWindow();
                    NetView.init();
                    order = 0;
                    stableOn = 0;
                    mouseWaitRelease();
                    break;
        case 0xF02:
        case dblLMB:
        case Right: if( !(((tNodeIdxRec*)current)->NdlNo & 0x80 ))break;
                    CurPtr = (tAddress*)current;
                    f = 1;
                    if( key != 0xF02 ){
                        releaseStr();
                        clrWindow();
                    }
                    PointView.activate();
                    if( !insearch )show( curPos );
                    stableOn = 0;
                    break;
        case 0xF01: if( isUnknown() && SearchView.AKAmatching ){
                        SearchView.AKAmatching = 0;
                        break;
                    }
                    CurPtr = (tAddress*)current;
                    CurAddr = *CurPtr;
                    if( SearchView.AKAmatching )SearchView.getSysop((char*)current);
                    f = 1;
                    releaseStr();
                    clrWindow();
                    SearchView.activate();
                    SearchView.clrWindow();
                    SearchView.lineCnt = 0;
                    if( !insearch ){
                        init();
                        show( curPos );
                    }
                    stableOn = 0;
                    break;
        case 0xF03:
                    order = 0;
                    if( StartupAddress.Net == CurAddr.Net && StartupAddress.Zone == CurAddr.Zone ){
                        StartupAddress.Zone = StartupAddress.Net = 0;
                        CurAddr.Zone = CurAddr.Net = 0;
                        curPos = curScr = 0;
                        init();
                    }else{
                        mungetch( CQuit );
                        mungetch( 0xF03 );
                        f = 0;
                    }
                    break;
        default:    TLevelView::handleEvent();
    }
}

