#include <io.h>
#include <malloc.h>
#include <string.h>
#include <process.h>
#include <stdio.h>
#include "view.h"
#include "sf-node.h"
#include "key.h"
#include "mouse.h"
#include "slice.h"

void TZoneView::init()
{
    unsigned int len, i, k, Zone=0xFFFF;
    tNodeIdxRec *NodeIdxRec;

    sliceCritical = 1;
    level = 1;

    StatusLine.say( readingIndex );
    offset = IdxOffset;
    if( !lineCnt ){
        lseek( handleIdx, offset, SEEK_SET );
        do{
            len = read( handleIdx, iobuff, sizeof(tNodeIdxRec)*100 )/sizeof(tNodeIdxRec);
            NodeIdxRec = (tNodeIdxRec*)iobuff;
            for( i=0; i<len; i++ ){
                if( Zone != NodeIdxRec[i].Address.Zone ){
                    lineCnt++;
                    Zone = NodeIdxRec[i].Address.Zone;
                    if( NodeIdxRec[ len-1 ].Address.Zone == Zone )goto NEXT;
                }
            }
NEXT:;
        }while( len == 100 );
    }
    lseek( handleIdx, offset, SEEK_SET );
    allocList( lineCnt );
    Zone = 0xFFFF;
    for( k = 0; ;  ){
        len = read( handleIdx, iobuff, sizeof(tNodeIdxRec)*100 )/sizeof(tNodeIdxRec);
        NodeIdxRec = (tNodeIdxRec*)iobuff;
        for( i=0; i<len; i++ ){
            if( Zone != NodeIdxRec[i].Address.Zone ){
                if( k < lineCnt ){
                    Zone = NodeIdxRec[i].Address.Zone;
                    NodeList[ k++ ].NodeIdxRec = NodeIdxRec[i];
                }
                continue;
            }
            if( Zone == NodeIdxRec[i].Address.Net && !NodeIdxRec[i].Address.Node && !NodeIdxRec[i].Address.Point){
                if( k <= lineCnt )NodeList[ k-1 ].NodeIdxRec = NodeIdxRec[i];
            }
            NodeList[ k-1 ].NodeIdxRec.NdlNo |= 0x80;
            if( k == lineCnt )if( NodeList[k-1].NodeIdxRec.Address.Zone == NodeList[k-1].NodeIdxRec.Address.Net )goto STP;
        }
        if( len != 100 )goto STP;
//        if( k == lineCnt )goto STP;
    }
STP:
    head = NodeList;
    current = &NodeList[ curPos ];
    if( insearch || StartupAddress.Zone || StartupAddress.Net || StartupAddress.Node || StartupAddress.Point ){
        while( ((tAddress*)current)->Zone < StartupAddress.Zone && curPos+1 < lineCnt ){
               curPos++;
               next();
        }
        if( ((tAddress*)current)->Zone == StartupAddress.Zone ){
                CurAddr.Zone = StartupAddress.Zone = 0;
                if( lineCnt - curPos < wLines ){
                    curScr = wLines - (lineCnt - curPos);
                    if( wLines > lineCnt )curScr -= (wLines-lineCnt);
                }
                if( !insearch || StartupAddress.Net || StartupAddress.Node || StartupAddress.Point ){
                    key = 0xF02;
                    handleEvent();
                }else{
                    collectStr();
                    if( insearch )mungetch( CInvalidate );
                    TView::NoDraw = insearch = 0;
                }
        }else{
               curPos = curScr = 0;
               current = head;
               sprintf( iobuff, "  \r  Zone %u%s", StartupAddress.Zone, doesntExist );
               WaitWindow( (unsigned char*)iobuff,
                     NULL, bkgError, clrError, clrError );
               StartupAddress.Zone = StartupAddress.Net = StartupAddress.Node = StartupAddress.Point = 0;
               insearch = 0;
               collectStr();
               mgetch();
               mouseWaitRelease();
        }
    }else{
        collectStr();
    }
    if( order )sort( order );
    sliceCritical = 0;
}

void  TZoneView::handleEvent()
{
    switch( key ){
        case 0xF02:
        case dblLMB:
        case Right: if( !(((tNodeIdxRec*)current)->NdlNo & 0x80 ))break;
                    CurPtr = (tAddress*)current;
                    if( key != 0xF02 ){
                        releaseStr();
                        clrWindow();
                    }
                    NetView.activate();
                    if( !insearch )show( curPos );
                    stableOn = 0;
                    break;
        case 0xF01: if( isUnknown() && SearchView.AKAmatching ){
                        SearchView.AKAmatching = 0;
                        break;
                    }
                    CurPtr = (tAddress*)current;
                    CurAddr = *CurPtr;
                    if( SearchView.AKAmatching )SearchView.getSysop((char*)current);
                    releaseStr();
                    clrWindow();
                    SearchView.activate();
                    SearchView.clrWindow();
                    SearchView.lineCnt = 0;
                    if( !insearch ){
                        init();
                        show( curPos );
                    }
                    stableOn = 0;
                    break;
        case 0xF03:
                    order = 0;
                    curPos = curScr = 0;
                    init();
                    break;
        default:    TLevelView::handleEvent();
    }
}

