#ifndef _VIEW_H_
#define _VIEW_H_

#include "tview.h"

class TLevelView :public TView{

    public:
    TLevelView();
//    void save();
//    void restore();
    void  next();
    void  prev();
    void  parseNodeLine( const char *buff, int i );
    int   collectStr(int isNow=0);
    void  releaseStr();
    void  sort( char ord = 0 );
    void  forceUpdate(void);
    void  info(void);
    char  * getLine();
    int   isSelected( void );
    void  wait( char *mess );
    int   isUnknown(const void*);
    int   isUnknown( void ){ return isUnknown(current); };
    void  handleEvent();
    void  activate();

    long  offset;
    char *scrBuff;
    char  order;
    int   level;
    void  * stableOn;
};

class TZoneView :public TLevelView{

    public:
    void  init();
    void  handleEvent();
};

class TNetView :public TLevelView{

    public:
    void  init();
    void  handleEvent();
};

class TNodeView :public TLevelView{

    public:
    void  init();
    void  handleEvent();
};

class TPointView :public TLevelView{

    public:
    void  init();
    void  handleEvent();
};

class TSearchView :public TLevelView{

    public:
    TSearchView();
    void  init();
    void  handleEvent();
    void  getSysop( char * ptr );
    int   AKAmatching;
};


#endif
